--- openoffice.org-2.0.2/xmlsecurity/source/dialogs/localize.sdf	2006-02-06 17:30:38.000000000 +0100
+++ openoffice.org-2.0.3/xmlsecurity/source/dialogs/localize.sdf	2006-05-09 17:15:33.000000000 +0200
@@ -3217,11 +3697,14 @@
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ko	보안 경고				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	lt	Saugumo įspėjimas				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	mk	Предупредување за безбедност				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ml-IN	സുരക്ഷ താക്കീത്				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	mr-IN	सुरक्षा सूचना				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	nb	Sikkerhetsadvarsel				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	nl	Beveiligingswaarschuwing				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	nn	Tryggleiksåtvaring				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	nr	IsiYeleliso sezokuVikeleka				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ns	Temošo ya Tšhireletšo				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	or-IN	ସୁରକ୍ଷା ଚେତାବନୀ				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	pa-IN	ਸੁਰੱਖਿਆ ਚੇਤਾਵਨੀ				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	pl	Ostrzeżenie dotyczące bezpieczeństwa				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	pt-BR	Alerta de segurança				2002-02-02 02:02:02
@@ -3234,10 +3717,14 @@
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	st	Tlhokomediso ya Polokeho				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	sv	Säkerhetsvarning				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	sw-TZ	Tahadhari ya Usalama				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ta-IN	பாதுகாப்பு எச்சரிக்கை				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	te-IN	Security Warning				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	tg	Огоҳии бехатарӣ				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	th	การเตือนความปลอดภัย				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	tn	Tsiboso ya Tshireletso				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	tr	Güvenlik Uyarısı				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ts	Xitsundzuxo xa vusirheleri				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ur-IN	حفاظتی آ گہی				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	ve	Tsivhudzo ya Tsiereledzo				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	vi	Cảnh báo bảo mật				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	xh	Isilumkiso Sokhuseleko				2002-02-02 02:02:02
@@ -3245,6 +3732,7 @@
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	zh-TW	安全警告				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	modaldialog	RID_XMLSECTP_MACROWARN		HID_XMLSEC_TP_MACROWARN		0	zu	Isexwayiso Sokuvikeleka				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	af	Bekyk handtekeninge...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	as-IN	স্বাক্ষৰবোৰ প্ৰদৰ্শন কৰক...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	be-BY	Паказаць сігнатуры...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	bg	Показване на подписите...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	bs	Pregledaj potpise...				2002-02-02 02:02:02
@@ -3260,6 +3748,7 @@
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	fi	Näytä allekirjoitukset...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	fr	Afficher les signatures...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	gu-IN	સહીઓ જુઓ...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	he	הצגת חתימות...‏				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	hi-IN	देखें हस्ताक्षर...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	hr	Pregledaj postpise...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	hu	Aláírások megtekintése...				2002-02-02 02:02:02
@@ -3269,11 +3758,14 @@
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	ko	서명 보기...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	lt	Rodyti parašus...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	mk	Прикажи ги потписите...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	ml-IN	കൈയോപ്പുകള് ദൃശ്യം				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	mr-IN	दृश्य स्वाक्षरी...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	nb	Vis signaturer ...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	nl	Handtekeningen bekijken...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	nn	Vis signaturar ...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	nr	Bona imiTlikitlo...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	ns	Lebelela Mesaeno...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	or-IN	ହସ୍ତାକ୍ଷରଗୁଡିକ ଦେଖ...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	pa-IN	ਦਸਤਖਤ ਵੇਖੋ...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	pl	Zobacz podpisy...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	pt-BR	Exibir assinaturas...				2002-02-02 02:02:02
@@ -3286,9 +3778,12 @@
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	st	Sheba Ditshaeno...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	sv	Visa signaturer...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	sw-TZ	View Signatures...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	te-IN	View Signatures...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	tg	Намоиши имзоҳо...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	th	ดูลายเซ็น...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	tr	İmzaları Görüntüle...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	ts	Vona minsayino...				2002-02-02 02:02:02
+xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	ur-IN	وئیودستخط۔۔۔				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	vi	Xem chữ ký...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	xh	Jonga Imityibelo...				2002-02-02 02:02:02
 xmlsecurity	source\dialogs\warnings.src	0	pushbutton	RID_XMLSECTP_MACROWARN	PB_VIEWSIGNS			0	zh-CN	查看签名...				2002-02-02 02:02:02
--- openoffice.org-2.0.2/xmlsecurity/source/dialogs/digitalsignaturesdialog.cxx	2006-02-07 11:25:56.000000000 +0100
+++ openoffice.org-2.0.3/xmlsecurity/source/dialogs/digitalsignaturesdialog.cxx	2006-04-07 16:23:57.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: digitalsignaturesdialog.cxx,v $
  *
- *  $Revision: 1.24 $
+ *  $Revision: 1.26 $
  *
- *  last change: $Author: rt $ $Date: 2006/02/07 10:25:56 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 14:23:57 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -36,6 +36,7 @@
 #include <xmlsecurity/certificatechooser.hxx>
 #include <xmlsecurity/certificateviewer.hxx>
 #include <xmlsecurity/biginteger.hxx>
+#include "xmlsecurity/baseencoding.hxx"
 
 #ifndef _COM_SUN_STAR_EMBED_XSTORAGE_HPP_
 #include <com/sun/star/embed/XStorage.hpp>
@@ -57,7 +58,6 @@
 #include <com/sun/star/packages/WrongPasswordException.hpp>
 #endif
 
-#include <tools/intn.hxx>
 #include <tools/date.hxx>
 #include <tools/time.hxx>
 
@@ -267,13 +267,15 @@
             {
                 DBG_ERROR( "Error in Certificate, problem with serial number!" );
                 return -1;
-            }
+			}
 
             maSignatureHelper.StartMission();
 
             sal_Int32 nSecurityId = maSignatureHelper.GetNewSecurityId();
-            maSignatureHelper.SetX509Certificate( nSecurityId, xCert->getIssuerName(), aCertSerial );
-
+			
+			maSignatureHelper.SetX509Certificate( nSecurityId, xCert->getIssuerName(), aCertSerial,
+				baseEncode(xCert->getEncoded(), BASE64));
+			
             std::vector< rtl::OUString > aElements = DocumentSignatureHelper::CreateElementList( mxStore, rtl::OUString(), meSignatureMode );
 
             ::rtl::OUString aXMLExt( RTL_CONSTASCII_USTRINGPARAM( "XML" ) );
--- openoffice.org-2.0.2/xmlsecurity/source/dialogs/resourcemanager.cxx	2005-09-09 19:13:15.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/dialogs/resourcemanager.cxx	2006-04-07 16:24:56.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: resourcemanager.cxx,v $
  *
- *  $Revision: 1.9 $
+ *  $Revision: 1.10 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:13:15 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 14:24:56 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -39,12 +39,13 @@
 #include <vcl/fixed.hxx>
 #include <svtools/stdctrl.hxx>
 #include <svtools/solar.hrc>
+#include <svtools/syslocale.hxx>
 
 
 namespace XmlSec
 {
 	static ResMgr*			pResMgr = 0;
-	static International*	pInternational = 0;
+    static SvtSysLocale*    pSysLocale = 0;
 
 	ResMgr* GetResMgr( void )
 	{
@@ -62,15 +63,11 @@
 	return pResMgr;
 	}
 
-	International* GetInternational( void )
+	const LocaleDataWrapper&    GetLocaleData( void )
 	{
-		if( !pInternational )
-		{
-//			LanguageType	aLang( LANGUAGE_ENGLISH_US );
-//			pInternational = new International( aLang );
-			pInternational = new International( Application::GetSettings().GetInternational() );
-		}
-		return pInternational;
+        if (!pSysLocale)
+            pSysLocale = new SvtSysLocale;
+        return pSysLocale->GetLocaleData();
 	}
 
 	DateTime GetDateTime( const ::com::sun::star::util::DateTime& _rDT )
@@ -84,10 +81,10 @@
 	{
         // --> PB 2004-10-12 #i20172# String with date and time information
         DateTime aDT( GetDateTime( _rDT ) );
-        International* pInter = GetInternational();
-        String sRet( pInter->GetDate( aDT ) );
+        const LocaleDataWrapper& rLoDa = GetLocaleData();
+        String sRet( rLoDa.getDate( aDT ) );
         sRet += ' ';
-        sRet += pInter->GetTime( aDT );
+        sRet += rLoDa.getTime( aDT );
         return sRet;
 	}
 
@@ -104,15 +101,16 @@
 
 		Date aDate( (USHORT)sDay.ToInt32(), (USHORT) sMonth.ToInt32(), (USHORT)sYear.ToInt32() );
 		Time aTime( sHour.ToInt32(), sMin.ToInt32(), sSec.ToInt32(), 0 );
-		String aStr( GetInternational()->GetDate( aDate ) );
+        const LocaleDataWrapper& rLoDa = GetLocaleData();
+		String aStr( rLoDa.getDate( aDate ) );
 		aStr.AppendAscii( " " );
-		aStr += GetInternational()->GetTime( aTime );
+		aStr += rLoDa.getTime( aTime );
 		return aStr;
 	}
 
 	String GetDateString( const ::com::sun::star::util::DateTime& _rDT )
 	{
-		return GetInternational()->GetDate( GetDateTime( _rDT ) );
+		return GetLocaleData().getDate( GetDateTime( _rDT ) );
 	}
 
 	String GetPureContent( const String& _rRawString, const char* _pCommaReplacement, bool _bPreserveId )
--- openoffice.org-2.0.2/xmlsecurity/source/dialogs/resourcemanager.hxx	2005-09-09 19:13:29.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/dialogs/resourcemanager.hxx	2006-04-07 16:25:13.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: resourcemanager.hxx,v $
  *
- *  $Revision: 1.5 $
+ *  $Revision: 1.6 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:13:29 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 14:25:13 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -39,9 +39,6 @@
 #ifndef _TOOLS_RESMGR_HXX
 #include <tools/resmgr.hxx>
 #endif
-#ifndef _TOOLS_INTN_HXX
-#include <tools/intn.hxx>
-#endif
 #ifndef _DATETIME_HXX
 #include <tools/datetime.hxx>
 #endif
@@ -55,12 +52,13 @@
 class FixedImage;
 class FixedInfo;
 class Control;
+class LocaleDataWrapper;
 
 namespace XmlSec
 {
 	ResMgr*			GetResMgr( void );
 
-	International*	GetInternational( void );
+	const LocaleDataWrapper&    GetLocaleData( void );
 	DateTime		GetDateTime( const ::com::sun::star::util::DateTime& _rDT );
 	String			GetDateTimeString( const ::com::sun::star::util::DateTime& _rDT );
 	String			GetDateTimeString( const rtl::OUString& _rDate, const rtl::OUString& _rTime );
--- openoffice.org-2.0.2/xmlsecurity/source/component/documentdigitalsignatures.cxx	2006-01-24 17:40:27.000000000 +0100
+++ openoffice.org-2.0.3/xmlsecurity/source/component/documentdigitalsignatures.cxx	2006-04-07 13:56:11.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: documentdigitalsignatures.cxx,v $
  *
- *  $Revision: 1.25 $
+ *  $Revision: 1.26 $
  *
- *  last change: $Author: hr $ $Date: 2006/01/24 16:40:27 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:56:11 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -287,8 +287,8 @@
             }
             else
             {
-                //We should always be aible to get the certificates because it is contained in the document.
-                OSL_ENSURE(0, "Could not create certificate");
+                //We should always be aible to get the certificates because it is contained in the document,
+				//unless the document is damaged so that signature xml file could not be parsed.
                 rSigInfo.CertificateStatus = css::security::CertificateValidity::INVALID;
             }
 
--- openoffice.org-2.0.2/xmlsecurity/source/helper/xmlsignaturehelper.cxx	2005-09-09 19:22:16.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/helper/xmlsignaturehelper.cxx	2006-04-07 13:56:44.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xmlsignaturehelper.cxx,v $
  *
- *  $Revision: 1.23 $
+ *  $Revision: 1.24 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:22:16 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:56:44 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -144,25 +144,29 @@
 void XMLSignatureHelper::SetX509Certificate( 
 		sal_Int32 nSecurityId,
 		const rtl::OUString& ouX509IssuerName,
-		const rtl::OUString& ouX509SerialNumber)
+		const rtl::OUString& ouX509SerialNumber,
+		const rtl::OUString& ouX509Cert)
 {
 	mpXSecController->setX509Certificate(
 		nSecurityId,
 		ouX509IssuerName,
-		ouX509SerialNumber);
+		ouX509SerialNumber,
+		ouX509Cert);
 }
 
 void XMLSignatureHelper::SetX509Certificate( 
 		sal_Int32 nSecurityId,
 		sal_Int32 nSecurityEnvironmentIndex,
 		const rtl::OUString& ouX509IssuerName,
-		const rtl::OUString& ouX509SerialNumber)
+		const rtl::OUString& ouX509SerialNumber,
+		const rtl::OUString& ouX509Cert)
 {
 	mpXSecController->setX509Certificate(
 		nSecurityId,
 		nSecurityEnvironmentIndex,
 		ouX509IssuerName,
-		ouX509SerialNumber);
+		ouX509SerialNumber,
+		ouX509Cert);
 }
 
 void XMLSignatureHelper::SetDateTime( sal_Int32 nSecurityId, const Date& rDate, const Time& rTime )
--- openoffice.org-2.0.2/xmlsecurity/source/helper/xsecctl.cxx	2005-09-09 19:23:02.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/helper/xsecctl.cxx	2006-04-07 13:56:56.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xsecctl.cxx,v $
  *
- *  $Revision: 1.7 $
+ *  $Revision: 1.8 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:23:02 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:56:56 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -179,7 +179,7 @@
 {
     sal_Bool bSuccess = sal_True;
 
-    rtl::OUString aDateStr, aTimeStr, sDoubleStr;
+    rtl::OUString aDateStr, aTimeStr, sHundredth;
     sal_Int32 nPos = rString.indexOf( (sal_Unicode) 'T' );
     sal_Int32 nPos2 = rString.indexOf( (sal_Unicode) ',' );
     if ( nPos >= 0 )
@@ -188,13 +188,31 @@
         if ( nPos2 >= 0 )
         {
             aTimeStr = rString.copy( nPos + 1, nPos2 - nPos - 1 );
-            sDoubleStr = rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("0."));
-            sDoubleStr += rString.copy( nPos2 + 1 );
+
+			//Get the fraction of a second with the accuracy of one hundreds second.
+			//The fraction part of the date could have different accuracies. To calculate 
+			//the count of a hundredth units one could form a fractional number by appending
+			//the value of the time string to 0. Then multiply it by 100 and use only the whole number.
+			//For example: 5:27:46,1 -> 0,1 * 100 = 10
+			//5:27:46,01 -> 0,01 * 100 = 1
+			//5:27:46,001 -> 0,001 * 100 = 0
+			//Due to the inaccuracy of floating point numbers the result may not be the same on different
+			//platforms. We had the case where we had a value of 24 hundredth of second, which converted to
+			//23 on Linux and 24 on Solaris and Windows.
+
+			//we only support a hundredth second
+			//make ,1 -> 10   ,01 -> 1    ,001 -> only use first two diggits
+			sHundredth = rString.copy(nPos2 + 1);
+			sal_Int32 len = sHundredth.getLength();
+			if (len == 1)
+				sHundredth += rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("0"));
+			if (len > 2)
+				sHundredth = sHundredth.copy(0, 2);
         }
         else
         {
             aTimeStr = rString.copy(nPos + 1);
-            sDoubleStr = rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("0.0"));
+			sHundredth = rtl::OUString(RTL_CONSTASCII_USTRINGPARAM("0"));
         }
     }
     else
@@ -264,7 +282,8 @@
         rDateTime.Hours = (sal_uInt16)nHour;
         rDateTime.Minutes = (sal_uInt16)nMin;
         rDateTime.Seconds = (sal_uInt16)nSec;
-        rDateTime.HundredthSeconds = sDoubleStr.toDouble() * 100;
+ //       rDateTime.HundredthSeconds = sDoubleStr.toDouble() * 100;
+		rDateTime.HundredthSeconds = static_cast<sal_uInt16>(sHundredth.toInt32());
     }
     return bSuccess;
 }
@@ -1335,7 +1354,18 @@
 						cssu::Reference< cssxs::XAttributeList > (pAttributeList));
 						
 					::rtl::OUStringBuffer buffer;
-					convertDateTime( buffer, signatureInfo.stDateTime );
+					//If the xml signature was already contained in the document, 
+					//then we use the original date and time string, rather then the 
+					//converted one. When the original string is converted to the DateTime 
+					//structure then information may be lost because it only holds a fractional
+					//of a second with a accuracy of one hundredth of second. If the string contains
+					//milli seconds (document was signed by an application other than OOo)
+					//and the converted time is written back, then the string looks different
+					//and the signature is broken.
+					if (signatureInfo.ouDateTime.getLength() > 0)
+						buffer = signatureInfo.ouDateTime;
+					else
+						convertDateTime( buffer, signatureInfo.stDateTime );
 					xDocumentHandler->characters( buffer.makeStringAndClear() );
 
 					xDocumentHandler->endElement( 
--- openoffice.org-2.0.2/xmlsecurity/source/helper/xsecctl.hxx	2005-09-09 19:23:17.000000000 +0200
+++ openoffice.org-2.0.3/xmlsecurity/source/helper/xsecctl.hxx	2006-04-07 13:57:11.000000000 +0200
@@ -4,9 +4,9 @@
  *
  *  $RCSfile: xsecctl.hxx,v $
  *
- *  $Revision: 1.9 $
+ *  $Revision: 1.10 $
  *
- *  last change: $Author: rt $ $Date: 2005/09/09 17:23:17 $
+ *  last change: $Author: vg $ $Date: 2006/04/07 11:57:11 $
  *
  *  The Contents of this file are made available subject to
  *  the terms of GNU Lesser General Public License Version 2.1.
@@ -490,16 +490,37 @@
 	void collectToSign( sal_Int32 securityId, const rtl::OUString& referenceId );
 	void signAStream( sal_Int32 securityId, const rtl::OUString& uri, const rtl::OUString& objectURL, sal_Bool isBinary);
 
+
+    /** sets data that describes the certificate.
+
+        It is absolutely necessary that the parameter ouX509IssuerName is set. It contains
+        the base64 encoded certificate, which is DER encoded. The XMLSec needs it to find
+        the private key. Although issuer name and certificate should be sufficient to identify
+        the certificate the implementation in XMLSec is broken, both for Windows and mozilla.
+        The reason is that they use functions to find the certificate which take as parameter
+        the DER encoded ASN.1 issuer name. The issuer name is a DName, where most attributes
+        are of type DirectoryName, which is a choice of 5 string types. This information is
+        not contained in the issuer string and while it is converted to the ASN.1 name the
+        conversion function must assume a particular type, which is often wrong. For example,
+        the Windows function CertStrToName will use a T.61 string if the string does not contain
+        special characters. So if the certificate uses simple characters but encodes the
+        issuer attributes in Utf8, then CertStrToName will use T.61. The resulting DER encoded
+        ASN.1 name now contains different bytes which indicate the string type. The functions
+        for finding the certificate apparently use memcmp - hence they fail to find the
+        certificate.
+     */
 	void setX509Certificate(
 		sal_Int32 nSecurityId,
 		const rtl::OUString& ouX509IssuerName,
-		const rtl::OUString& ouX509SerialNumber);
-        
+		const rtl::OUString& ouX509SerialNumber,
+		const rtl::OUString& ouX509Cert);
+    // see the other setX509Certifcate function    
 	void setX509Certificate(
 		sal_Int32 nSecurityId,
 		const sal_Int32	nSecurityEnvironmentIndex,
 		const rtl::OUString& ouX509IssuerName,
-		const rtl::OUString& ouX509SerialNumber);
+		const rtl::OUString& ouX509SerialNumber,
+		const rtl::OUString& ouX509Cert);
 
 	void setDate(
 		sal_Int32 nSecurityId,
